/* 
 * termserver (C) 1999 Andrew J. Kroll (GPL) See file COPYING
 
			     ______________
			    /\            /\ 
			   /  \  modems  /  \
			  /    \        /    \
			 / pppd \__on__/ wrap \ 
			 \      /      \      /
			  \    /        \    /
			   \  / networks \  /
			    \/____________\/


Special thanks to Alan Cox for explaining tty/pty's and how they
interconnect, as well as a few of his code snippits...
(of which I shamelessly stole.)


 */
#define THIS_IS_TERMSERVER
#define TRUE     1
#define FALSE    0

#ifdef CIBAUD
# if defined(__STDC__) || defined(__ANSI_CPP__)
#  define BAUD(x)  { #x, CIBAUD|CBAUD, B ## x }
# else
#  define BAUD(x)  { "x", CIBAUD|CBAUD, B/**/x }
# endif
#else
# if defined(__STDC__) || defined(__ANSI_CPP__)
#  define BAUD(x)  { #x, CBAUD, B ## x }
# else
#  define BAUD(x)  { "x", CBAUD, B/**/x }
# endif
#endif /* CIBAUD */

#ifndef DEFAULT_LINE
#define DEFAULT_LINE "/dev/modem"
#define BAUDON
#endif

#define PORT 6969

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <time.h>
#include <termios.h>


#ifdef UNIX98_YUCK
#include <bits/stropts.h>

#endif

#include "common.h"

#define TERMIO termios
#include <termios.h>

#include <arpa/telnet.h>

struct TERMIO tty_old, tty_new;


int a,b,c,d;
int sock, sockr;
char greeting[1024]; /* should be more than enough */
char copybuf[1024]; /* should be more than enough */
int flag=1;
long foo;
struct sockaddr_in srv_addy;
struct sockaddr_in clt_addy;
unsigned int client_len;
struct timeval tout;
struct timeval mydelay;
fd_set rd;
fd_set td;
int nodetach;
int updatend, ndupdated;
time_t ndctime;
int oops=0;

int tty;

void problemo (char *string)
{
	time_t logtime;

	flock(tty, LOCK_UN);
	if(sock>0) { shutdown(sock,0); close(sock); }
	time(&logtime);
	printf("[%s] %s\n",strpn(ctime(&logtime)),string);
	fflush(stdout);
	fflush(stdout);
	sleep(1);
	exit(-1);
}

#include "snag.h"

void setdtr (int tty_fd, int on)
{ 
	int modembits = TIOCM_DTR;
	ioctl(tty_fd, (on ? TIOCMBIS : TIOCMBIC), &modembits);
} 


void cclosed(void)
{
	problemo("Program exited\n\n");
}

void normalclose(void)
{
	time_t logtime;
	if(sock>0) { shutdown(sock,0); close(sock); }
	time(&logtime);
	printf("[%s] Connection from %i.%i.%i.%i. *CLOSED*\n",strpn(ctime(&logtime)),a,b,c,d);
	fflush(stdout);
}

void initsocks(int argc,char *argv[])
{
	mydelay.tv_sec = 0;
	mydelay.tv_usec = 50000;
	tout.tv_sec=30;
	tout.tv_usec=0;
	client_len=sizeof(struct sockaddr_in);
	
	
	sockr=socket(AF_INET, SOCK_STREAM, 0);
	bzero ((char *) &srv_addy.sin_addr.s_addr, sizeof(srv_addy.sin_addr.s_addr));
	srv_addy.sin_family=AF_INET;
	srv_addy.sin_port=htons((argc>=3 && atoi(argv[2])>0) ? atoi(argv[2]) : PORT);
	/* this should just wait... */
	{
		time_t logtime;
		time(&logtime);
		printf("[%s] Waiting for socket...", strpn(ctime(&logtime)));
		if (!nodetach) printf("\n");
	}
	setsockopt(sockr, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(int));
	while(bind(sockr, (struct sockaddr *)&srv_addy, sizeof(srv_addy))<0) {
		if (nodetach) printf(".");
		sleep(2);
	} /* try to bind to address infinitely */
	if (nodetach) printf("\n");
	{
		time_t logtime;
		time(&logtime);
		printf("[%s] Got it!\n", strpn(ctime(&logtime)));
	}
	listen(sockr, 1);
}

void fuckoff(void)
{
	time_t logtime;
	sprintf(greeting,
		"Your hack attempt from IP %i.%i.%i.%i has been logged,\nhave a nice day assmunch! NOT! :-)\n",
		a,b,c,d);
	write(sock,greeting,strlen(greeting));
	time(&logtime);
	printf("[%s] ***WARNING*** Possible HACKER @ %i.%i.%i.%i\n", strpn(ctime(&logtime)),a,b,c,d);
}

/* check DCD */
int checkdcd(int ttyX)
{
	int xdcd=0;
	int mosta;
	if (ioctl(ttyX,TIOCMGET,&mosta) > -1) {	/* Get line status. */
		if ((mosta & TIOCM_CAR) != 0) {	/* Check if CD is low. */
			xdcd=1;			/* DCD on */
		} else {
			xdcd=0;			/* DCD off */
		}
	}
	return(xdcd);
}	


void process(int ttyx)
{
/* #define MAXIO 2048 */
	char ch[MAXIO];
	int dsize;
	int ret;
	int dcd=0,ok=0;
	
	/* drop/raise DTR, say Ready. */
	setdtr(ttyx, FALSE);
	sleep(1);
	setdtr(ttyx, TRUE);
	
	/* say ready, start modem abuse */
	do {
		ret = write(sock,"\r\n\r\n",4);
	} while( ret == -1 && errno==EINTR);

	do { 
		ret = write(sock,TOOLVER,strlen(TOOLVER));
	} while( ret == -1 && errno==EINTR);
	
	do {
		ret = write(sock,"\r\n\r\nReady.\r\n\r\n",14);
	} while( ret == -1 && errno==EINTR);
	/* start suck loop */
	for (;;) {
		dcd=checkdcd(ttyx);
		if((dcd==0) && (ok==1)) return; /* carrier lost */
		ok=dcd;
		FD_ZERO(&rd); FD_SET(sock,&rd); FD_SET(ttyx,&rd);
		(void) select(32,&rd,0,0,0);

		/* sock -> modem */
		if(FD_ISSET(sock,&rd)) {
			dsize=read(sock,(void *) &ch, MAXIO);
			if (dsize == 0) return; /* socket lost */
			do {
				ret = write(ttyx,&ch, dsize); 
			} while( ret == -1 && errno==EINTR);
		}

		/* modem -> sock */
		if (FD_ISSET(ttyx, &rd)) {
			dsize=read(ttyx,(void *) &ch, MAXIO);
			if (dsize == 0) return; /* carrier lost */
			do {
				ret = write(sock,&ch,dsize); 
			} while( ret == -1 && errno==EINTR);
		}
	}
}



void accep(void)
{
	time_t logtime;

	for(sock=-1;sock<0;) {
		sock=accept(sockr, (struct sockaddr *)&clt_addy,(int *)&client_len);
		if(sock > 0) {
			d=clt_addy.sin_addr.s_addr >> 24 & 255;
			c=clt_addy.sin_addr.s_addr >> 16 & 255;
			b=clt_addy.sin_addr.s_addr >> 8 & 255; 
			a=clt_addy.sin_addr.s_addr & 255; 
			foo=clt_addy.sin_addr.s_addr;
			setsockopt(sock,SOL_TCP,TCP_NODELAY,&flag, sizeof(int));
			sprintf(greeting,"Your IP is %i.%i.%i.%i\n",a,b,c,d); 
			write(sock,greeting,strlen(greeting));
			time(&logtime);
			printf("[%s] MODEM connection from %i.%i.%i.%i\n",strpn(ctime(&logtime)),a,b,c,d);
		}
	}
}


int main(int argc,char *argv[])
{
	int tmp;
	ndupdated=1;
	updatend=0;
	
	if (!(nodetach=((argc>1) && (!strcmp(argv[1], "-nodetach"))))) {
		int stront,stront2;
		int p;
		if ((stront=open("/dev/null", O_RDWR))<0)
			{perror("Can't open /dev/null"); exit(1);}
		if ((stront2=open("/root/modem.log", O_WRONLY|O_CREAT|O_APPEND, S_IRWXU))<0)
			{perror("Can't open logfile"); exit(1);}
		if ((p = fork()) < 0) return -1;
		if (p != 0) exit(0);
		setsid();
		dup2(stront, 0);
		dup2(stront2, 1);
		dup2(stront2, 2);
		close(stront); close(stront2);
	        chdir("/");                                                                                
	} else {
		for(tmp=1; tmp<(argc-1);) {
			argv[tmp]=argv[tmp++];
		}
		argc--;
	}
	/* open modem */
	tty = open(DEFAULT_LINE, O_RDWR|O_NDELAY);
	if (flock(tty, LOCK_EX|LOCK_NB) == -1 && errno == EWOULDBLOCK) {
		fputs("TTY line in use.\n", stderr);
			return 1;
		}
	set_termios(tty, 38400);
	
	signal(SIGPIPE,(__sighandler_t)cclosed);
	signal(SIGHUP,(__sighandler_t)cclosed);
	signal(SIGINT,(__sighandler_t)cclosed);
	signal(SIGQUIT,(__sighandler_t)cclosed);
	signal(SIGKILL,(__sighandler_t)cclosed);
	sock=-1;
	initsocks(argc,argv);			/* bind port */
	setdtr(tty, FALSE);			/* dtr off! */
	sleep(1);
	for(;;) {
		sock=-1;
		accep();			/* wait for request */
		if(sock>0) { 			/* stupid, but it may help */
			process(tty);		/* process connection */
			setdtr(tty, FALSE);	/* dtr off! */
			sleep(1);
			normalclose();		/* close connection, if still exists, and try again */
		}
	}
	/* never reached, this is here to shut up gcc, course
	   it would be nice if gcc on LinuxNET would shut up sometimes... :-)
	   /me ducks
	*/
	exit(0);
}

